% Quantile Treatment Effects and Bootstrap Inference under Covariate-Adaptive Randomization 
% Yichong Zhang, Xin Zheng
% 2020/02/14

% [Generate Table 1 and Figure 1]



clear;clc;
load('combine_200');
mu = 1;
%% QTE, H0
rej_q = mean(abs(T_q_naive)>1.96,4);
rej_q_adj = mean(abs(squeeze(T_q_adj(:,:,:,:,6)))>1.96,4);
rej_q_boot_naive = mean(abs(T_q_b_naive)>1.96,4);
rej_q_ipw_boot_naive = mean(abs(T_q_b_ipw_naive)>1.96,4);



rej_q_boot = mean(abs(T_q_b)>1.96,4);
rej_q_ipw_boot = mean(abs(T_q_b_ipw)>1.96,4);
for t = 1:length(taulist)
    rej_temp1 = rej_q(:,:,t)';
    rej_temp2 = rej_q_adj(:,:,t)';
    rej_temp3 = rej_q_boot_naive(:,:,t)';
    rej_temp4 = rej_q_ipw_boot_naive(:,:,t)';
    rej_temp5 = rej_q_boot(:,:,t)';
    rej_temp6 = rej_q_ipw_boot(:,:,t)';
    rej_0_qte(:,1+6*(t-1):6+6*(t-1)) = [rej_temp1(:),rej_temp2(:),rej_temp3(:),......
        rej_temp4(:),rej_temp5(:),rej_temp6(:)];
end

%% QTE H1
rej_q = mean(abs(T_q_naive+mu/std_q_naive)>1.96,4);
rej_q_adj = mean(abs(squeeze(T_q_adj(:,:,:,:,6)+mu/std_q_adj(:,:,:,:,6)))>1.96,4);
rej_q_boot_naive = mean(abs(T_q_b_naive+mu/str_q_b_naive)>1.96,4);
rej_q_ipw_boot_naive = mean(abs(T_q_b_ipw_naive + mu/str_q_b_ipw_naive)>1.96,4);



rej_q_boot = mean(abs(T_q_b+mu/str_q_b)>1.96,4);
rej_q_ipw_boot = mean(abs(T_q_b_ipw+mu/str_q_b_ipw)>1.96,4);

for t = 1:length(taulist)
    rej_temp1 = rej_q(:,:,t)';
    rej_temp2 = rej_q_adj(:,:,t)';
    rej_temp3 = rej_q_boot_naive(:,:,t)';
    rej_temp4 = rej_q_ipw_boot_naive(:,:,t)';
    rej_temp5 = rej_q_boot(:,:,t)';
    rej_temp6 = rej_q_ipw_boot(:,:,t)';
    rej_1_qte(:,1+6*(t-1):6+6*(t-1)) = [rej_temp1(:),rej_temp2(:),rej_temp3(:),......
        rej_temp4(:),rej_temp5(:),rej_temp6(:)];
end

output_table1 = [rej_0_qte(1:4,7:12),rej_1_qte(1:4,7:12);rej_0_qte(9:12,7:12),rej_1_qte(9:12,7:12)];
save('table1.mat','output_table1');

%% plot against h
for h = 1:H
rej_q_adj = mean(abs(squeeze(T_q_adj(:,:,:,:,h)))>1.96,4);
rej_temp2 = rej_q_adj(:,:,2,:)';
rej_q_2(:,h) = rej_temp2(:);
end

subplot(1,2,1)
plot(Hlist,rej_q_2(3+4*0,:),'k')
hold on
hx = get(gca,'XLim');
plot(hx,[rej_0_qte(3+4*0,14),rej_0_qte(3+4*0,14)],'black-.','LineWidth',1)
hold off
% set(gca,'XLim',[0.25 0.75])
set(gca,'YLim',[0 0.1])
title('DGP 1');
subplot(1,2,2)
plot(Hlist,rej_q_2(3+4*2,:),'k')
hold on
hx = get(gca,'XLim');
plot(hx,[rej_0_qte(3+4*2,14),rej_0_qte(3+4*2,14)],'black-.','LineWidth',1)
hold off
% set(gca,'XLim',[0.25 0.75])
set(gca,'YLim',[0 0.1])
title('DGP 2');
saveas(gcf,'figure1.fig')
% 












