% Quantile Treatment Effects and Bootstrap Inference under Covariate-Adaptive Randomization 
% Yichong Zhang, Xin Zheng
% 2020/02/14

% [Generate Treatment Assignment]

% idx2: index of the assignment rule.
%       idx2=1 for SRS; idx2=2 for SBR.
% S   : covariates
% pi  : pi, targeted assignment probability. 


function A = AR(idx2,S,pi)
n = length(S);g = max(S);A = zeros(n,1);

if idx2 == 1
    A = (rand(n,1)<pi);
elseif idx2 == 2
    A = zeros(n,1);
    for s = 1:g
        count1 = (S==s);
        idx = zeros(n,1);
        for i = 1:n
            idx(i,1) = sum(count1(1:i));
        end
        count2 = [(1:n)',count1.*idx];
        ns = sum(count1);
        ms = floor(pi*ns);
        idxa = randsample(ns,ms,false)';
        idxd = zeros(n,1);
        for i = 1:ms
            idxd = idxd+(count2(:,2)==idxa(i));
        end
        A(idxd==1,1)=1;
        
    end
    
end
