% Quantile Treatment Effects and Bootstrap Inference under Covariate-Adaptive Randomization 
% Yichong Zhang, Xin Zheng
% 2020/02/14

% [Generate Table 3]

clear;clc;
load('combine_200');
mu = 1;

%% QTE, H0

rej_q = mean(abs(T_q_naive)>1.96,4);
rej_q_adj = mean(abs(squeeze(T_q_adj(:,:,:,:,6)))>1.96,4);
rej_q_boot_naive = mean(abs(T_q_b_naive)>1.96,4);
rej_q_ipw_boot_naive = mean(abs(T_q_b_ipw_naive)>1.96,4);



rej_q_boot = mean(abs(T_q_b)>1.96,4);
rej_q_ipw_boot = mean(abs(T_q_b_ipw)>1.96,4);
for t = 1:length(taulist)
    rej_temp1 = rej_q(:,:,t)';
    rej_temp2 = rej_q_adj(:,:,t)';
    rej_temp3 = rej_q_boot_naive(:,:,t)';
    rej_temp4 = rej_q_ipw_boot_naive(:,:,t)';
    rej_temp5 = rej_q_boot(:,:,t)';
    rej_temp6 = rej_q_ipw_boot(:,:,t)';
    rej_0_qte(:,1+6*(t-1):6+6*(t-1)) = [rej_temp1(:),rej_temp2(:),rej_temp3(:),......
        rej_temp4(:),rej_temp5(:),rej_temp6(:)];
end

%% QTE H1

rej_q = mean(abs(T_q_naive+mu/std_q_naive)>1.96,4);
rej_q_adj = mean(abs(squeeze(T_q_adj(:,:,:,:,6)+mu/std_q_adj(:,:,:,:,6)))>1.96,4);
rej_q_boot_naive = mean(abs(T_q_b_naive+mu/str_q_b_naive)>1.96,4);
rej_q_ipw_boot_naive = mean(abs(T_q_b_ipw_naive + mu/str_q_b_ipw_naive)>1.96,4);



rej_q_boot = mean(abs(T_q_b+mu/str_q_b)>1.96,4);
rej_q_ipw_boot = mean(abs(T_q_b_ipw+mu/str_q_b_ipw)>1.96,4);

for t = 1:length(taulist)
    rej_temp1 = rej_q(:,:,t)';
    rej_temp2 = rej_q_adj(:,:,t)';
    rej_temp3 = rej_q_boot_naive(:,:,t)';
    rej_temp4 = rej_q_ipw_boot_naive(:,:,t)';
    rej_temp5 = rej_q_boot(:,:,t)';
    rej_temp6 = rej_q_ipw_boot(:,:,t)';
    rej_1_qte(:,1+6*(t-1):6+6*(t-1)) = [rej_temp1(:),rej_temp2(:),rej_temp3(:),......
        rej_temp4(:),rej_temp5(:),rej_temp6(:)];
end
output_table3 = [rej_0_qte(1:2,7:12),rej_1_qte(1:2,7:12);rej_0_qte(9:10,7:12),rej_1_qte(9:10,7:12)];
save('table3.mat','output_table3');
